setwd("~/Dropbox/CollabBeaulieu/estimatesForRaboFig4")
library(ape)
library(diversitree)

treefiles<-c("e75s06.500.trees", "e75s00.trees")
library(geiger)
for (file.index in sequence(length(treefiles))) {
trees<-read.tree(treefiles[file.index])
trees.500 <- trees[which(sapply(trees, Ntip)>=500)]
rm(trees)
results.df <- data.frame()
desired.ntax.v<-50*c(2:(floor(max(sapply(trees.500, Ntip))/50 )))
for (tree.index in sequence(length(trees.500))) {
	print(paste("done ", tree.index/ length(trees.500)))
	phy.trimmed <- trees.500[[tree.index]]
	bd <- NA
	yule <- NA
	try(p <- starting.point.bd(phy.trimmed), silent=TRUE)
	try(lik.bd <- make.bd(phy.trimmed), silent=TRUE)
	try(bd <- find.mle(lik.bd,p,method="subplex"), silent=TRUE)
	try(lik.yule <- constrain(lik.bd,mu~0), silent=TRUE)
	try(yule <- find.mle(lik.yule,p,method="subplex"), silent=TRUE)
	if(!is.na(bd[1]) & !is.na(yule[1])) {
		local.result<-data.frame(file=treefiles[file.index], treeNum=tree.index, ntaxOrig=Ntip(trees.500[[tree.index]]), ntaxFinal=Ntip(phy.trimmed), t=max(branching.times(phy.trimmed)), bd.b=bd$par[1], bd.e=bd$par[2], bd.loglik=bd$lnLik, yule.b=yule$par[1], yule.loglik=yule$lnLik, sampleCorrection=2) #sampleCorrection: 0 if not used, 1 if used, 2 if not needed b/c actual tree
		#print(local.result)
		results.df<-rbind(results.df, local.result)
	}
	for(ntax.index in sequence(length(desired.ntax.v))) {
		ntax.to.prune <- Ntip(trees.500[[tree.index]]) - desired.ntax.v[ntax.index]
		if(ntax.to.prune > 0) {
			phy.trimmed <- drop.random(trees.500[[tree.index]], ntax.to.prune)
			bd <- NA
			yule <- NA
			try(p <- starting.point.bd(phy.trimmed), silent=TRUE)
			try(lik.bd <- make.bd(phy.trimmed, sampling.f = Ntip(phy.trimmed) / Ntip(trees.500[[tree.index]])), silent=TRUE)
			try(bd <- find.mle(lik.bd,p,method="subplex"), silent=TRUE)
			try(lik.yule <- constrain(lik.bd,mu~0), silent=TRUE)
			try(yule <- find.mle(lik.yule,p,method="subplex"), silent=TRUE)
			if(!is.na(bd[1]) & !is.na(yule[1])) {
				local.result<-data.frame(file=treefiles[file.index], treeNum=tree.index, ntaxOrig=Ntip(trees.500[[tree.index]]), ntaxFinal=Ntip(phy.trimmed), t=max(branching.times(phy.trimmed)), bd.b=bd$par[1], bd.e=bd$par[2], bd.loglik=bd$lnLik, yule.b=yule$par[1], yule.loglik=yule$lnLik, sampleCorrection=1) #sampleCorrection: 0 if not used, 1 if used, 2 if not needed b/c actual tree
				results.df<-rbind(results.df, local.result)
			}
			
			bd <- NA
			yule <- NA
			try(p <- starting.point.bd(phy.trimmed), silent=TRUE)
			try(lik.bd <- make.bd(phy.trimmed), silent=TRUE)
			try(bd <- find.mle(lik.bd,p,method="subplex"), silent=TRUE)
			try(lik.yule <- constrain(lik.bd,mu~0), silent=TRUE)
			try(yule <- find.mle(lik.yule,p,method="subplex"), silent=TRUE)
			if(!is.na(bd[1]) & !is.na(yule[1])) {
				local.result<-data.frame(file=treefiles[file.index], treeNum=tree.index, ntaxOrig=Ntip(trees.500[[tree.index]]), ntaxFinal=Ntip(phy.trimmed), t=max(branching.times(phy.trimmed)), bd.b=bd$par[1], bd.e=bd$par[2], bd.loglik=bd$lnLik, yule.b=yule$par[1], yule.loglik=yule$lnLik, sampleCorrection=0) #sampleCorrection: 0 if not used, 1 if used, 2 if not needed b/c actual tree
				results.df<-rbind(results.df, local.result)
			}
		}
	}
	save(results.df, file="Fig4s06.Rsave")
}
}
