
library(geiger)
source("evolveRateTree_JMB_sqT.R")
#source("birthdeath.R")

b=0.1959547
eps=0.75
stdev=0.00

for(i in 1:2000){
	gg<-NULL
	while(is.null(gg)){
		try(mm<-evolveRateTree.eps(b=b,eps=eps,stdev=stdev,maxtax=5000))
		gg<-drop.extinct(mm)
#		ape.bd <- birthdeath(gg)
#		b = ape.bd$para[2] / (1-ape.bd$para[1])
#		d = (ape.bd$para[2] * ape.bd$para[1]) / (1-ape.bd$para[1])
#		names(b)<-NULL
#		names(d)<-NULL						
	}
#	write.table(t(c(b,d)),file="e75s00.bdest",quote=F,sep="\t",row.names=F,col.names=F,append=TRUE)
	write.tree(gg,file="e75s00.500.trees",append=TRUE)
}

stdev=0.06
for(i in 1:2000){
	gg<-NULL
	while(is.null(gg)){
		mm<-evolveRateTree.eps(b=b,eps=eps,stdev=stdev,maxtax=5000)
		gg<-drop.extinct(mm)
#		ape.bd <- birthdeath(gg)
#		b = ape.bd$para[2] / (1-ape.bd$para[1])
#		d = (ape.bd$para[2] * ape.bd$para[1]) / (1-ape.bd$para[1])
#		names(b)<-NULL
#		names(d)<-NULL		
	}
#	write.table(t(c(b,d)),file="e75s06T.bdest",quote=F,sep="\t",row.names=F,col.names=F,append=TRUE)
	write.tree(gg,file="e75s06T.trees",append=TRUE)
}

max.time=50
for(k in 1:100){
	gg<-NULL
	while(is.null(gg)){
		try(mm<-evolveRateTree.eps(b=b,eps=eps,stdev=stdev,maxtax=100000))
		gg<-drop.extinct(mm)
	}
	###INTERVAL ALGORITHM:
	tree.mat<-cbind(mm$edge,mm$birth.time,mm$end.time,mm$lambda)
	res<-c()
	for(i in  seq(from = 1, by = 2, length.out = Nnode(mm))){
		j <- i + 1L
		split.interval.start<-tree.mat[i,3]
		split.interval.stop<-min(tree.mat[which(tree.mat[,4]>split.interval.start),4])
		lambda.interval<-tree.mat[which(tree.mat[,3]<=split.interval.start & tree.mat[,4]>=split.interval.stop | tree.mat[,3]<=split.interval.start & tree.mat[,4]>=split.interval.start),5]
		res<-rbind(res,c(split.interval.start,max(lambda.interval),min(lambda.interval),mean(lambda.interval)))
	}
	res<-res[order(res[,1]),]
	res<-rbind(res,c(max.time,res[dim(res)[1],2],res[dim(res)[1],3],res[dim(res)[1],4]))
	res[,1]<-max.time-res[,1]
	#####################
	string1<-paste("wait.e75s06T",k,sep="_")
	try(write.table(Ntip(gg), paste(string1,"tre"), quote=FALSE, row.name=FALSE, col.name=FALSE))
	write.table(res, file=string1, sep="\t", quote=F, row.name=F, col.name=F)
	string1<-paste("tooManye75s06T", k, sep="_")
	write.table(sum(mm$too.many), file=string1, sep="\t",quote=FALSE,row.name=FALSE,col.name=FALSE)
}


source("evolveRateTree_JMB_sqT.R")

stdev=0.06
for(i in 1:2000){
	gg<-NULL
	while(is.null(gg)){
		mm<-evolveRateTree.eps(b=b,eps=eps,stdev=stdev,maxtax=5000)
		gg<-drop.extinct(mm)
#		ape.bd <- birthdeath(gg)
#		b = ape.bd$para[2] / (1-ape.bd$para[1])
#		d = (ape.bd$para[2] * ape.bd$para[1]) / (1-ape.bd$para[1])
#		names(b)<-NULL
#		names(d)<-NULL		
	}
#	write.table(t(c(b,d)),file="e75s06sT.bdest",quote=F,sep="\t",row.names=F,col.names=F,append=TRUE)
	write.tree(gg,file="e75s06sT.trees",append=TRUE)
}

for(k in 1:100){
	gg<-NULL
	while(is.null(gg)){
		try(mm<-evolveRateTree.eps(b=b,eps=eps,stdev=stdev,maxtax=100000))
		gg<-drop.extinct(mm)
	}
	###INTERVAL ALGORITHM:
	tree.mat<-cbind(mm$edge,mm$birth.time,mm$end.time,mm$lambda)
	res<-c()
	for(i in  seq(from = 1, by = 2, length.out = Nnode(mm))){
		j <- i + 1L
		split.interval.start<-tree.mat[i,3]
		split.interval.stop<-min(tree.mat[which(tree.mat[,4]>split.interval.start),4])
		lambda.interval<-tree.mat[which(tree.mat[,3]<=split.interval.start & tree.mat[,4]>=split.interval.stop | tree.mat[,3]<=split.interval.start & tree.mat[,4]>=split.interval.start),5]
		res<-rbind(res,c(split.interval.start,max(lambda.interval),min(lambda.interval),mean(lambda.interval)))
	}
	res<-res[order(res[,1]),]
	res<-rbind(res,c(max.time,res[dim(res)[1],2],res[dim(res)[1],3],res[dim(res)[1],4]))
	res[,1]<-max.time-res[,1]
	#####################
	string1<-paste("wait.e75s06sT",k,sep="_")
	try(write.table(Ntip(gg), paste(string1,"tre"), quote=FALSE, row.name=FALSE, col.name=FALSE))
	write.table(res, file=string1, sep="\t", quote=F, row.name=F, col.name=F)
	string1<-paste("tooManye75s06sT", k, sep="_")
	write.table(sum(mm$too.many), file=string1, sep="\t",quote=FALSE,row.name=FALSE,col.name=FALSE)
}


